#include <errno.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/time.h>
#include <stdio.h>
#include <ctype.h>
#include "haven.h"

extern int signalmask;
extern char *malloc(), *index(), *strcpy();
extern int uptime;
extern int reboot;
extern int sock;
extern char hc_name[];
extern int numconnect;
extern int connectcount;
extern int connectthishr;

extern int hc_port;
extern struct splayer *players;
char sendbuf[BUFSIZE];

#ifndef errno
extern int errno;
#endif

#ifndef FD_SET
#define fd_set  int
#define FD_SET(n,p)     (*(p) |= 1 << (n))
#define FD_CLR(n,p)     (*(p) &= ~(1 << (n)))
#define FD_ISSET(n,p)   (*(p) & 1 << (n))
#define FD_ZERO(p)      (*(p) = 0)
#endif

#undef CTRL
#define CTRL(x) ('x' & 037)  /* I got tired of playing guess the ascii */

extern int getsock(), infromsock(), outtosock(), acceptcon(), atoi();
extern struct splayer *players;	/* the linked list of players records */
char recvbuf[BUFSIZE];
extern int mflag,maxcap;

int s;			/* our initial socket */
fd_set needread;        /* for seeing which fds we need to read from */    

int
doit(port)
     int port;
{
  initplayerstuct();
  
  if (gethostname(sendbuf, sizeof(sendbuf)) == -1) {
    fprintf(stderr, "haven: Error gettign hostname!\n");
    exit(2);
  }
  if(reboot) {
    s = sock;
    FD_SET(s, &needread);
    rebootend();
  } else 
    s = getsock(sendbuf, port);
  
  printf("CONTROL SOCKET: %d\n",s);
  
  while (1 == 1) {
    FD_ZERO(&needread);
    FD_SET(s, &needread);
    setfds(&needread);
    if (select((maxcap+4), &needread, (fd_set *)0,
	       (fd_set *)0, (struct timeval *)0) == -1) {
      if (errno != EINTR) {
	continue;
      } else
	continue; /* do it again and get it right */
    }
    
    if (FD_ISSET(s, &needread)) {
      if (newplayer(s) == -1) {
      }
    }    
    handleinput(needread);
  }
}

int rebootstart()
{
  int fp;
  FILE *file;
  struct splayer *pplayer;
  char a1[80];
  char a2[80];

  if((file = fopen("playerstruct" , "w")) == NULL) return -1;

  /** added for Kaz by Maikeru Long 25 Apr 1997 **/
  sprintf(sendbuf, "%d\n", uptime);
  fputs(sendbuf, file);
  
  for(pplayer=players->next; pplayer; pplayer=pplayer->next) {
    sprintf(sendbuf, "%d\n", pplayer->seclevel);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->channel);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%d\n", pplayer->ln);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%d\n", pplayer->s);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%d\n", pplayer->query);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%ld\n", pplayer->flags);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%ld\n", pplayer->flag2);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%ld\n", pplayer->idle);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%ld\n", pplayer->contime);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%d\n", pplayer->wrap);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->invchan);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%d\n", pplayer->invline);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%d\n", pplayer->lastp);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->object);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%c\n", pplayer->gender);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->idlemesg);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->desc);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->arrmesg);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->wandmesg);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->joinmesg);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->useraddr);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->exitmesg);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%d\n", pplayer->col);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->onfrom);
    fputs(sendbuf, file);
    sprintf(sendbuf, "%s\n", pplayer->realonfrom);
    fputs(sendbuf, file);     
    sprintf(sendbuf, "%s\n", pplayer->name);
    fputs(sendbuf, file);
  }
  fclose(file);
  sprintf(a1, "-r%d", s);
  sprintf(a2, "%d", hc_port);
  sprintf(sendbuf, "[SYSLOG: EXECUTING REBOOT on port %s]\r\n", a2);
  sendall(sendbuf,"*",SYSLOG2,0);

  /*close(s);*/
  execl(hc_name, hc_name, a1, a2, (char *)0);
}

int rebootend()
{
  int fp;
  int count;
  FILE *file;
  char string[BUFSIZE];
  struct splayer *new;
  struct splayer *buf;
  struct timeval tmptime;
  struct timezone tmpzone;
 
  if((fp=open("playerstruct",0)) == -1) {
printf("oh shit... can't open\r\n");
return;
}
  
  if((file=fdopen(fp, "r")) == NULL) {
printf("oh shit... can't open\r\n");
    return;
  }
  
  /** Added for Kaz by Maikeru Long 25 Apr 1997 **/
  fgets(string, 40, file);
  uptime=atoi(string);

  while(fgets(string, 40, file) != NULL) {
    buf = players;
    while (buf->next != (struct splayer *)0)
      buf = buf->next;

    buf->next = (struct splayer *) malloc(sizeof (struct splayer));
    buf = buf->next;
     
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->seclevel = atoi(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    strcpy(buf->channel, string);
  
    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->ln = atoi(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->s = atoi(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->query = atoi(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->flags = atol(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->flag2 = atol(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->idle = atol(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->contime = atol(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->wrap = atoi(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    strcpy(buf->invchan, string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->invline = atoi(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->lastp = atoi(string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    strcpy(buf->object, string);

    fgets(string, 40, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->gender =  string[0];

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    strcpy(buf->idlemesg, string);

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->desc = allocmem(sizeof(string));
    strcpy(buf->desc, string);

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->arrmesg = allocmem(sizeof(string));
    strcpy(buf->arrmesg, string);

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->wandmesg = allocmem(sizeof(string));
    strcpy(buf->wandmesg, string);

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->joinmesg = allocmem(sizeof(string));
    strcpy(buf->joinmesg, string);

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->useraddr = allocmem(sizeof(string));
    strcpy(buf->useraddr, string);

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->exitmesg = allocmem(sizeof(string));
    strcpy(buf->exitmesg, string);

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    buf->col = atoi(string);

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    strcpy(buf->onfrom, string);

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    strcpy(buf->realonfrom, string);

    fgets(string, BUFSIZE, file);
    if (string[strlen(string)-1] == '\n')
      string[strlen(string)-1] = '\000';
    strcpy(buf->name, string);

    gettimeofday(&tmptime, &tmpzone);
    buf->contime = tmptime.tv_sec;

    for (count = 0; count < RECALL_SIZE; count++)
      buf->pagebuffer[count][0] = '\0';
    for (count = 0; count < LINEMAX; count++) {
      buf->gag[count] = 0;
      buf->hilite[count] = 0;
    }

    buf->lastans = 0.0;
    buf->lastpage[0] = '\000';
    buf->moretype = none;
    buf->moreline = 0;
    buf->morearg[0] = '\0';
    buf->morearg[28] = '\0';
    buf->morearg[29] = '\0';
    buf->linemodebuf[0] = '\000';
    buf->lineindex = 0;
    buf->lps = 0;
    buf->next = (struct splayer *)0;

    numconnect++;
    connectcount++;
    connectthishr++;
    
    FD_SET(buf->ln, &needread);

  }
  sendall("[SYSLOG: REBOOT COMPLETE]\r\n","*",SYSLOG2, 0);
  close(fp);
  fclose(file);
}
